#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;
typedef pair<double, double> pd;

void dfs(int s, int q, vector<vector<int>> gr, vector<bool>& vis) {
	if (vis[s]) return;
	if (q == 0) return;
	vis[s] = true;
	for (auto adj : gr[s]) {
		dfs(adj, q - 1, gr, vis);
	}
}

int main() {
	int n, m, k;
	
	cin >> n >> m >> k;

	vector<bool> vis(n + 1, false);
	vector<vector<int>> gr(n + 1);

	for (int i = 0; i < m; i++) {
		int a, b; cin >> a >> b;
		gr[a].push_back(b);
		gr[b].push_back(a);
	}

	

	for (int i = 0; i < k; i++) {
		int p, h; cin >> p >> h;
		dfs(p, h, gr, vis);
	}

	int cnt = 0;
	for (int i = 0; i < n + 1; i++) {
		cnt += vis[i];
	}

	cout << cnt << endl;
	for (int i = 0; i < n + 1; i++) {
		if (vis[i]) cout << i << ' ';
	}

	system("pause");

	return 0;
}